// Code generated by go-swagger; DO NOT EDIT.

package annotations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewPostAnnotationParams creates a new PostAnnotationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAnnotationParams() *PostAnnotationParams {
	return &PostAnnotationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAnnotationParamsWithTimeout creates a new PostAnnotationParams object
// with the ability to set a timeout on a request.
func NewPostAnnotationParamsWithTimeout(timeout time.Duration) *PostAnnotationParams {
	return &PostAnnotationParams{
		timeout: timeout,
	}
}

// NewPostAnnotationParamsWithContext creates a new PostAnnotationParams object
// with the ability to set a context for a request.
func NewPostAnnotationParamsWithContext(ctx context.Context) *PostAnnotationParams {
	return &PostAnnotationParams{
		Context: ctx,
	}
}

// NewPostAnnotationParamsWithHTTPClient creates a new PostAnnotationParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAnnotationParamsWithHTTPClient(client *http.Client) *PostAnnotationParams {
	return &PostAnnotationParams{
		HTTPClient: client,
	}
}

/*
PostAnnotationParams contains all the parameters to send to the API endpoint

	for the post annotation operation.

	Typically these are written to a http.Request.
*/
type PostAnnotationParams struct {

	// Body.
	Body *models.PostAnnotationsCmd

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post annotation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAnnotationParams) WithDefaults() *PostAnnotationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post annotation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAnnotationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post annotation params
func (o *PostAnnotationParams) WithTimeout(timeout time.Duration) *PostAnnotationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post annotation params
func (o *PostAnnotationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post annotation params
func (o *PostAnnotationParams) WithContext(ctx context.Context) *PostAnnotationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post annotation params
func (o *PostAnnotationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post annotation params
func (o *PostAnnotationParams) WithHTTPClient(client *http.Client) *PostAnnotationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post annotation params
func (o *PostAnnotationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post annotation params
func (o *PostAnnotationParams) WithBody(body *models.PostAnnotationsCmd) *PostAnnotationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post annotation params
func (o *PostAnnotationParams) SetBody(body *models.PostAnnotationsCmd) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostAnnotationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
