// Code generated by go-swagger; DO NOT EDIT.

package correlations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetCorrelationParams creates a new GetCorrelationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetCorrelationParams() *GetCorrelationParams {
	return &GetCorrelationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetCorrelationParamsWithTimeout creates a new GetCorrelationParams object
// with the ability to set a timeout on a request.
func NewGetCorrelationParamsWithTimeout(timeout time.Duration) *GetCorrelationParams {
	return &GetCorrelationParams{
		timeout: timeout,
	}
}

// NewGetCorrelationParamsWithContext creates a new GetCorrelationParams object
// with the ability to set a context for a request.
func NewGetCorrelationParamsWithContext(ctx context.Context) *GetCorrelationParams {
	return &GetCorrelationParams{
		Context: ctx,
	}
}

// NewGetCorrelationParamsWithHTTPClient creates a new GetCorrelationParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetCorrelationParamsWithHTTPClient(client *http.Client) *GetCorrelationParams {
	return &GetCorrelationParams{
		HTTPClient: client,
	}
}

/*
GetCorrelationParams contains all the parameters to send to the API endpoint

	for the get correlation operation.

	Typically these are written to a http.Request.
*/
type GetCorrelationParams struct {

	// CorrelationUID.
	CorrelationUID string

	// SourceUID.
	SourceUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get correlation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCorrelationParams) WithDefaults() *GetCorrelationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get correlation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCorrelationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get correlation params
func (o *GetCorrelationParams) WithTimeout(timeout time.Duration) *GetCorrelationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get correlation params
func (o *GetCorrelationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get correlation params
func (o *GetCorrelationParams) WithContext(ctx context.Context) *GetCorrelationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get correlation params
func (o *GetCorrelationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get correlation params
func (o *GetCorrelationParams) WithHTTPClient(client *http.Client) *GetCorrelationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get correlation params
func (o *GetCorrelationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCorrelationUID adds the correlationUID to the get correlation params
func (o *GetCorrelationParams) WithCorrelationUID(correlationUID string) *GetCorrelationParams {
	o.SetCorrelationUID(correlationUID)
	return o
}

// SetCorrelationUID adds the correlationUid to the get correlation params
func (o *GetCorrelationParams) SetCorrelationUID(correlationUID string) {
	o.CorrelationUID = correlationUID
}

// WithSourceUID adds the sourceUID to the get correlation params
func (o *GetCorrelationParams) WithSourceUID(sourceUID string) *GetCorrelationParams {
	o.SetSourceUID(sourceUID)
	return o
}

// SetSourceUID adds the sourceUid to the get correlation params
func (o *GetCorrelationParams) SetSourceUID(sourceUID string) {
	o.SourceUID = sourceUID
}

// WriteToRequest writes these params to a swagger request
func (o *GetCorrelationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param correlationUID
	if err := r.SetPathParam("correlationUID", o.CorrelationUID); err != nil {
		return err
	}

	// path param sourceUID
	if err := r.SetPathParam("sourceUID", o.SourceUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
