// Code generated by go-swagger; DO NOT EDIT.

package dashboards

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewTrimDashboardParams creates a new TrimDashboardParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTrimDashboardParams() *TrimDashboardParams {
	return &TrimDashboardParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTrimDashboardParamsWithTimeout creates a new TrimDashboardParams object
// with the ability to set a timeout on a request.
func NewTrimDashboardParamsWithTimeout(timeout time.Duration) *TrimDashboardParams {
	return &TrimDashboardParams{
		timeout: timeout,
	}
}

// NewTrimDashboardParamsWithContext creates a new TrimDashboardParams object
// with the ability to set a context for a request.
func NewTrimDashboardParamsWithContext(ctx context.Context) *TrimDashboardParams {
	return &TrimDashboardParams{
		Context: ctx,
	}
}

// NewTrimDashboardParamsWithHTTPClient creates a new TrimDashboardParams object
// with the ability to set a custom HTTPClient for a request.
func NewTrimDashboardParamsWithHTTPClient(client *http.Client) *TrimDashboardParams {
	return &TrimDashboardParams{
		HTTPClient: client,
	}
}

/*
TrimDashboardParams contains all the parameters to send to the API endpoint

	for the trim dashboard operation.

	Typically these are written to a http.Request.
*/
type TrimDashboardParams struct {

	// Body.
	Body *models.TrimDashboardCommand

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the trim dashboard params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TrimDashboardParams) WithDefaults() *TrimDashboardParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the trim dashboard params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TrimDashboardParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the trim dashboard params
func (o *TrimDashboardParams) WithTimeout(timeout time.Duration) *TrimDashboardParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the trim dashboard params
func (o *TrimDashboardParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the trim dashboard params
func (o *TrimDashboardParams) WithContext(ctx context.Context) *TrimDashboardParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the trim dashboard params
func (o *TrimDashboardParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the trim dashboard params
func (o *TrimDashboardParams) WithHTTPClient(client *http.Client) *TrimDashboardParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the trim dashboard params
func (o *TrimDashboardParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the trim dashboard params
func (o *TrimDashboardParams) WithBody(body *models.TrimDashboardCommand) *TrimDashboardParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the trim dashboard params
func (o *TrimDashboardParams) SetBody(body *models.TrimDashboardCommand) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *TrimDashboardParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
