// Code generated by go-swagger; DO NOT EDIT.

package datasource_permissions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// DisablePermissionsReader is a Reader for the DisablePermissions structure.
type DisablePermissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DisablePermissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDisablePermissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewDisablePermissionsBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewDisablePermissionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDisablePermissionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDisablePermissionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDisablePermissionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[POST /datasources/{datasourceId}/disable-permissions] disablePermissions", response, response.Code())
	}
}

// NewDisablePermissionsOK creates a DisablePermissionsOK with default headers values
func NewDisablePermissionsOK() *DisablePermissionsOK {
	return &DisablePermissionsOK{}
}

/*
DisablePermissionsOK describes a response with status code 200, with default header values.

(empty)
*/
type DisablePermissionsOK struct {
	Payload *models.DisablePermissionsOKBody
}

// IsSuccess returns true when this disable permissions Ok response has a 2xx status code
func (o *DisablePermissionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this disable permissions Ok response has a 3xx status code
func (o *DisablePermissionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions Ok response has a 4xx status code
func (o *DisablePermissionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this disable permissions Ok response has a 5xx status code
func (o *DisablePermissionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this disable permissions Ok response a status code equal to that given
func (o *DisablePermissionsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the disable permissions Ok response
func (o *DisablePermissionsOK) Code() int {
	return 200
}

func (o *DisablePermissionsOK) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsOk  %+v", 200, o.Payload)
}

func (o *DisablePermissionsOK) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsOk  %+v", 200, o.Payload)
}

func (o *DisablePermissionsOK) GetPayload() *models.DisablePermissionsOKBody {
	return o.Payload
}

func (o *DisablePermissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DisablePermissionsOKBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDisablePermissionsBadRequest creates a DisablePermissionsBadRequest with default headers values
func NewDisablePermissionsBadRequest() *DisablePermissionsBadRequest {
	return &DisablePermissionsBadRequest{}
}

/*
DisablePermissionsBadRequest describes a response with status code 400, with default header values.

BadRequestError is returned when the request is invalid and it cannot be processed.
*/
type DisablePermissionsBadRequest struct {
	Payload *models.ErrorResponseBody
}

// IsSuccess returns true when this disable permissions bad request response has a 2xx status code
func (o *DisablePermissionsBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this disable permissions bad request response has a 3xx status code
func (o *DisablePermissionsBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions bad request response has a 4xx status code
func (o *DisablePermissionsBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this disable permissions bad request response has a 5xx status code
func (o *DisablePermissionsBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this disable permissions bad request response a status code equal to that given
func (o *DisablePermissionsBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the disable permissions bad request response
func (o *DisablePermissionsBadRequest) Code() int {
	return 400
}

func (o *DisablePermissionsBadRequest) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsBadRequest  %+v", 400, o.Payload)
}

func (o *DisablePermissionsBadRequest) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsBadRequest  %+v", 400, o.Payload)
}

func (o *DisablePermissionsBadRequest) GetPayload() *models.ErrorResponseBody {
	return o.Payload
}

func (o *DisablePermissionsBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponseBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDisablePermissionsUnauthorized creates a DisablePermissionsUnauthorized with default headers values
func NewDisablePermissionsUnauthorized() *DisablePermissionsUnauthorized {
	return &DisablePermissionsUnauthorized{}
}

/*
DisablePermissionsUnauthorized describes a response with status code 401, with default header values.

UnauthorizedError is returned when the request is not authenticated.
*/
type DisablePermissionsUnauthorized struct {
	Payload *models.ErrorResponseBody
}

// IsSuccess returns true when this disable permissions unauthorized response has a 2xx status code
func (o *DisablePermissionsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this disable permissions unauthorized response has a 3xx status code
func (o *DisablePermissionsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions unauthorized response has a 4xx status code
func (o *DisablePermissionsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this disable permissions unauthorized response has a 5xx status code
func (o *DisablePermissionsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this disable permissions unauthorized response a status code equal to that given
func (o *DisablePermissionsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the disable permissions unauthorized response
func (o *DisablePermissionsUnauthorized) Code() int {
	return 401
}

func (o *DisablePermissionsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsUnauthorized  %+v", 401, o.Payload)
}

func (o *DisablePermissionsUnauthorized) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsUnauthorized  %+v", 401, o.Payload)
}

func (o *DisablePermissionsUnauthorized) GetPayload() *models.ErrorResponseBody {
	return o.Payload
}

func (o *DisablePermissionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponseBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDisablePermissionsForbidden creates a DisablePermissionsForbidden with default headers values
func NewDisablePermissionsForbidden() *DisablePermissionsForbidden {
	return &DisablePermissionsForbidden{}
}

/*
DisablePermissionsForbidden describes a response with status code 403, with default header values.

ForbiddenError is returned if the user/token has insufficient permissions to access the requested resource.
*/
type DisablePermissionsForbidden struct {
	Payload *models.ErrorResponseBody
}

// IsSuccess returns true when this disable permissions forbidden response has a 2xx status code
func (o *DisablePermissionsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this disable permissions forbidden response has a 3xx status code
func (o *DisablePermissionsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions forbidden response has a 4xx status code
func (o *DisablePermissionsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this disable permissions forbidden response has a 5xx status code
func (o *DisablePermissionsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this disable permissions forbidden response a status code equal to that given
func (o *DisablePermissionsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the disable permissions forbidden response
func (o *DisablePermissionsForbidden) Code() int {
	return 403
}

func (o *DisablePermissionsForbidden) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsForbidden  %+v", 403, o.Payload)
}

func (o *DisablePermissionsForbidden) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsForbidden  %+v", 403, o.Payload)
}

func (o *DisablePermissionsForbidden) GetPayload() *models.ErrorResponseBody {
	return o.Payload
}

func (o *DisablePermissionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponseBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDisablePermissionsNotFound creates a DisablePermissionsNotFound with default headers values
func NewDisablePermissionsNotFound() *DisablePermissionsNotFound {
	return &DisablePermissionsNotFound{}
}

/*
DisablePermissionsNotFound describes a response with status code 404, with default header values.

NotFoundError is returned when the requested resource was not found.
*/
type DisablePermissionsNotFound struct {
	Payload *models.ErrorResponseBody
}

// IsSuccess returns true when this disable permissions not found response has a 2xx status code
func (o *DisablePermissionsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this disable permissions not found response has a 3xx status code
func (o *DisablePermissionsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions not found response has a 4xx status code
func (o *DisablePermissionsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this disable permissions not found response has a 5xx status code
func (o *DisablePermissionsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this disable permissions not found response a status code equal to that given
func (o *DisablePermissionsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the disable permissions not found response
func (o *DisablePermissionsNotFound) Code() int {
	return 404
}

func (o *DisablePermissionsNotFound) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsNotFound  %+v", 404, o.Payload)
}

func (o *DisablePermissionsNotFound) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsNotFound  %+v", 404, o.Payload)
}

func (o *DisablePermissionsNotFound) GetPayload() *models.ErrorResponseBody {
	return o.Payload
}

func (o *DisablePermissionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponseBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDisablePermissionsInternalServerError creates a DisablePermissionsInternalServerError with default headers values
func NewDisablePermissionsInternalServerError() *DisablePermissionsInternalServerError {
	return &DisablePermissionsInternalServerError{}
}

/*
DisablePermissionsInternalServerError describes a response with status code 500, with default header values.

InternalServerError is a general error indicating something went wrong internally.
*/
type DisablePermissionsInternalServerError struct {
	Payload *models.ErrorResponseBody
}

// IsSuccess returns true when this disable permissions internal server error response has a 2xx status code
func (o *DisablePermissionsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this disable permissions internal server error response has a 3xx status code
func (o *DisablePermissionsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this disable permissions internal server error response has a 4xx status code
func (o *DisablePermissionsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this disable permissions internal server error response has a 5xx status code
func (o *DisablePermissionsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this disable permissions internal server error response a status code equal to that given
func (o *DisablePermissionsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the disable permissions internal server error response
func (o *DisablePermissionsInternalServerError) Code() int {
	return 500
}

func (o *DisablePermissionsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsInternalServerError  %+v", 500, o.Payload)
}

func (o *DisablePermissionsInternalServerError) String() string {
	return fmt.Sprintf("[POST /datasources/{datasourceId}/disable-permissions][%d] disablePermissionsInternalServerError  %+v", 500, o.Payload)
}

func (o *DisablePermissionsInternalServerError) GetPayload() *models.ErrorResponseBody {
	return o.Payload
}

func (o *DisablePermissionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponseBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
