// Code generated by go-swagger; DO NOT EDIT.

package datasource_permissions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewEnablePermissionsParams creates a new EnablePermissionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEnablePermissionsParams() *EnablePermissionsParams {
	return &EnablePermissionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEnablePermissionsParamsWithTimeout creates a new EnablePermissionsParams object
// with the ability to set a timeout on a request.
func NewEnablePermissionsParamsWithTimeout(timeout time.Duration) *EnablePermissionsParams {
	return &EnablePermissionsParams{
		timeout: timeout,
	}
}

// NewEnablePermissionsParamsWithContext creates a new EnablePermissionsParams object
// with the ability to set a context for a request.
func NewEnablePermissionsParamsWithContext(ctx context.Context) *EnablePermissionsParams {
	return &EnablePermissionsParams{
		Context: ctx,
	}
}

// NewEnablePermissionsParamsWithHTTPClient creates a new EnablePermissionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewEnablePermissionsParamsWithHTTPClient(client *http.Client) *EnablePermissionsParams {
	return &EnablePermissionsParams{
		HTTPClient: client,
	}
}

/*
EnablePermissionsParams contains all the parameters to send to the API endpoint

	for the enable permissions operation.

	Typically these are written to a http.Request.
*/
type EnablePermissionsParams struct {

	// DatasourceID.
	DatasourceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the enable permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnablePermissionsParams) WithDefaults() *EnablePermissionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the enable permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnablePermissionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the enable permissions params
func (o *EnablePermissionsParams) WithTimeout(timeout time.Duration) *EnablePermissionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the enable permissions params
func (o *EnablePermissionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the enable permissions params
func (o *EnablePermissionsParams) WithContext(ctx context.Context) *EnablePermissionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the enable permissions params
func (o *EnablePermissionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the enable permissions params
func (o *EnablePermissionsParams) WithHTTPClient(client *http.Client) *EnablePermissionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the enable permissions params
func (o *EnablePermissionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDatasourceID adds the datasourceID to the enable permissions params
func (o *EnablePermissionsParams) WithDatasourceID(datasourceID string) *EnablePermissionsParams {
	o.SetDatasourceID(datasourceID)
	return o
}

// SetDatasourceID adds the datasourceId to the enable permissions params
func (o *EnablePermissionsParams) SetDatasourceID(datasourceID string) {
	o.DatasourceID = datasourceID
}

// WriteToRequest writes these params to a swagger request
func (o *EnablePermissionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param datasourceId
	if err := r.SetPathParam("datasourceId", o.DatasourceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
