// Code generated by go-swagger; DO NOT EDIT.

package folder_permissions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewUpdateFolderPermissionsParams creates a new UpdateFolderPermissionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateFolderPermissionsParams() *UpdateFolderPermissionsParams {
	return &UpdateFolderPermissionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateFolderPermissionsParamsWithTimeout creates a new UpdateFolderPermissionsParams object
// with the ability to set a timeout on a request.
func NewUpdateFolderPermissionsParamsWithTimeout(timeout time.Duration) *UpdateFolderPermissionsParams {
	return &UpdateFolderPermissionsParams{
		timeout: timeout,
	}
}

// NewUpdateFolderPermissionsParamsWithContext creates a new UpdateFolderPermissionsParams object
// with the ability to set a context for a request.
func NewUpdateFolderPermissionsParamsWithContext(ctx context.Context) *UpdateFolderPermissionsParams {
	return &UpdateFolderPermissionsParams{
		Context: ctx,
	}
}

// NewUpdateFolderPermissionsParamsWithHTTPClient creates a new UpdateFolderPermissionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateFolderPermissionsParamsWithHTTPClient(client *http.Client) *UpdateFolderPermissionsParams {
	return &UpdateFolderPermissionsParams{
		HTTPClient: client,
	}
}

/*
UpdateFolderPermissionsParams contains all the parameters to send to the API endpoint

	for the update folder permissions operation.

	Typically these are written to a http.Request.
*/
type UpdateFolderPermissionsParams struct {

	// Body.
	Body *models.UpdateDashboardACLCommand

	// FolderUID.
	FolderUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update folder permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateFolderPermissionsParams) WithDefaults() *UpdateFolderPermissionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update folder permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateFolderPermissionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update folder permissions params
func (o *UpdateFolderPermissionsParams) WithTimeout(timeout time.Duration) *UpdateFolderPermissionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update folder permissions params
func (o *UpdateFolderPermissionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update folder permissions params
func (o *UpdateFolderPermissionsParams) WithContext(ctx context.Context) *UpdateFolderPermissionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update folder permissions params
func (o *UpdateFolderPermissionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update folder permissions params
func (o *UpdateFolderPermissionsParams) WithHTTPClient(client *http.Client) *UpdateFolderPermissionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update folder permissions params
func (o *UpdateFolderPermissionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update folder permissions params
func (o *UpdateFolderPermissionsParams) WithBody(body *models.UpdateDashboardACLCommand) *UpdateFolderPermissionsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update folder permissions params
func (o *UpdateFolderPermissionsParams) SetBody(body *models.UpdateDashboardACLCommand) {
	o.Body = body
}

// WithFolderUID adds the folderUID to the update folder permissions params
func (o *UpdateFolderPermissionsParams) WithFolderUID(folderUID string) *UpdateFolderPermissionsParams {
	o.SetFolderUID(folderUID)
	return o
}

// SetFolderUID adds the folderUid to the update folder permissions params
func (o *UpdateFolderPermissionsParams) SetFolderUID(folderUID string) {
	o.FolderUID = folderUID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateFolderPermissionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param folder_uid
	if err := r.SetPathParam("folder_uid", o.FolderUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
