// Code generated by go-swagger; DO NOT EDIT.

package legacy_alerts_notification_channels

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewNotificationChannelTestParams creates a new NotificationChannelTestParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNotificationChannelTestParams() *NotificationChannelTestParams {
	return &NotificationChannelTestParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNotificationChannelTestParamsWithTimeout creates a new NotificationChannelTestParams object
// with the ability to set a timeout on a request.
func NewNotificationChannelTestParamsWithTimeout(timeout time.Duration) *NotificationChannelTestParams {
	return &NotificationChannelTestParams{
		timeout: timeout,
	}
}

// NewNotificationChannelTestParamsWithContext creates a new NotificationChannelTestParams object
// with the ability to set a context for a request.
func NewNotificationChannelTestParamsWithContext(ctx context.Context) *NotificationChannelTestParams {
	return &NotificationChannelTestParams{
		Context: ctx,
	}
}

// NewNotificationChannelTestParamsWithHTTPClient creates a new NotificationChannelTestParams object
// with the ability to set a custom HTTPClient for a request.
func NewNotificationChannelTestParamsWithHTTPClient(client *http.Client) *NotificationChannelTestParams {
	return &NotificationChannelTestParams{
		HTTPClient: client,
	}
}

/*
NotificationChannelTestParams contains all the parameters to send to the API endpoint

	for the notification channel test operation.

	Typically these are written to a http.Request.
*/
type NotificationChannelTestParams struct {

	// Body.
	Body *models.NotificationTestCommand

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the notification channel test params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NotificationChannelTestParams) WithDefaults() *NotificationChannelTestParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the notification channel test params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NotificationChannelTestParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the notification channel test params
func (o *NotificationChannelTestParams) WithTimeout(timeout time.Duration) *NotificationChannelTestParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the notification channel test params
func (o *NotificationChannelTestParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the notification channel test params
func (o *NotificationChannelTestParams) WithContext(ctx context.Context) *NotificationChannelTestParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the notification channel test params
func (o *NotificationChannelTestParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the notification channel test params
func (o *NotificationChannelTestParams) WithHTTPClient(client *http.Client) *NotificationChannelTestParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the notification channel test params
func (o *NotificationChannelTestParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the notification channel test params
func (o *NotificationChannelTestParams) WithBody(body *models.NotificationTestCommand) *NotificationChannelTestParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the notification channel test params
func (o *NotificationChannelTestParams) SetBody(body *models.NotificationTestCommand) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *NotificationChannelTestParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
