// Code generated by go-swagger; DO NOT EDIT.

package recording_rules

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewCreateRecordingRuleParams creates a new CreateRecordingRuleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateRecordingRuleParams() *CreateRecordingRuleParams {
	return &CreateRecordingRuleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateRecordingRuleParamsWithTimeout creates a new CreateRecordingRuleParams object
// with the ability to set a timeout on a request.
func NewCreateRecordingRuleParamsWithTimeout(timeout time.Duration) *CreateRecordingRuleParams {
	return &CreateRecordingRuleParams{
		timeout: timeout,
	}
}

// NewCreateRecordingRuleParamsWithContext creates a new CreateRecordingRuleParams object
// with the ability to set a context for a request.
func NewCreateRecordingRuleParamsWithContext(ctx context.Context) *CreateRecordingRuleParams {
	return &CreateRecordingRuleParams{
		Context: ctx,
	}
}

// NewCreateRecordingRuleParamsWithHTTPClient creates a new CreateRecordingRuleParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateRecordingRuleParamsWithHTTPClient(client *http.Client) *CreateRecordingRuleParams {
	return &CreateRecordingRuleParams{
		HTTPClient: client,
	}
}

/*
CreateRecordingRuleParams contains all the parameters to send to the API endpoint

	for the create recording rule operation.

	Typically these are written to a http.Request.
*/
type CreateRecordingRuleParams struct {

	// Body.
	Body *models.RecordingRuleJSON

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create recording rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRecordingRuleParams) WithDefaults() *CreateRecordingRuleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create recording rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRecordingRuleParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create recording rule params
func (o *CreateRecordingRuleParams) WithTimeout(timeout time.Duration) *CreateRecordingRuleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create recording rule params
func (o *CreateRecordingRuleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create recording rule params
func (o *CreateRecordingRuleParams) WithContext(ctx context.Context) *CreateRecordingRuleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create recording rule params
func (o *CreateRecordingRuleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create recording rule params
func (o *CreateRecordingRuleParams) WithHTTPClient(client *http.Client) *CreateRecordingRuleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create recording rule params
func (o *CreateRecordingRuleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create recording rule params
func (o *CreateRecordingRuleParams) WithBody(body *models.RecordingRuleJSON) *CreateRecordingRuleParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create recording rule params
func (o *CreateRecordingRuleParams) SetBody(body *models.RecordingRuleJSON) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateRecordingRuleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
