// Code generated by go-swagger; DO NOT EDIT.

package reports

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewSendTestEmailParams creates a new SendTestEmailParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSendTestEmailParams() *SendTestEmailParams {
	return &SendTestEmailParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSendTestEmailParamsWithTimeout creates a new SendTestEmailParams object
// with the ability to set a timeout on a request.
func NewSendTestEmailParamsWithTimeout(timeout time.Duration) *SendTestEmailParams {
	return &SendTestEmailParams{
		timeout: timeout,
	}
}

// NewSendTestEmailParamsWithContext creates a new SendTestEmailParams object
// with the ability to set a context for a request.
func NewSendTestEmailParamsWithContext(ctx context.Context) *SendTestEmailParams {
	return &SendTestEmailParams{
		Context: ctx,
	}
}

// NewSendTestEmailParamsWithHTTPClient creates a new SendTestEmailParams object
// with the ability to set a custom HTTPClient for a request.
func NewSendTestEmailParamsWithHTTPClient(client *http.Client) *SendTestEmailParams {
	return &SendTestEmailParams{
		HTTPClient: client,
	}
}

/*
SendTestEmailParams contains all the parameters to send to the API endpoint

	for the send test email operation.

	Typically these are written to a http.Request.
*/
type SendTestEmailParams struct {

	// Body.
	Body *models.CreateOrUpdateConfigCmd

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the send test email params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SendTestEmailParams) WithDefaults() *SendTestEmailParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the send test email params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SendTestEmailParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the send test email params
func (o *SendTestEmailParams) WithTimeout(timeout time.Duration) *SendTestEmailParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the send test email params
func (o *SendTestEmailParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the send test email params
func (o *SendTestEmailParams) WithContext(ctx context.Context) *SendTestEmailParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the send test email params
func (o *SendTestEmailParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the send test email params
func (o *SendTestEmailParams) WithHTTPClient(client *http.Client) *SendTestEmailParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the send test email params
func (o *SendTestEmailParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the send test email params
func (o *SendTestEmailParams) WithBody(body *models.CreateOrUpdateConfigCmd) *SendTestEmailParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the send test email params
func (o *SendTestEmailParams) SetBody(body *models.CreateOrUpdateConfigCmd) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *SendTestEmailParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
