// Code generated by go-swagger; DO NOT EDIT.

package signed_in_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewUpdateSignedInUserParams creates a new UpdateSignedInUserParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateSignedInUserParams() *UpdateSignedInUserParams {
	return &UpdateSignedInUserParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateSignedInUserParamsWithTimeout creates a new UpdateSignedInUserParams object
// with the ability to set a timeout on a request.
func NewUpdateSignedInUserParamsWithTimeout(timeout time.Duration) *UpdateSignedInUserParams {
	return &UpdateSignedInUserParams{
		timeout: timeout,
	}
}

// NewUpdateSignedInUserParamsWithContext creates a new UpdateSignedInUserParams object
// with the ability to set a context for a request.
func NewUpdateSignedInUserParamsWithContext(ctx context.Context) *UpdateSignedInUserParams {
	return &UpdateSignedInUserParams{
		Context: ctx,
	}
}

// NewUpdateSignedInUserParamsWithHTTPClient creates a new UpdateSignedInUserParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateSignedInUserParamsWithHTTPClient(client *http.Client) *UpdateSignedInUserParams {
	return &UpdateSignedInUserParams{
		HTTPClient: client,
	}
}

/*
UpdateSignedInUserParams contains all the parameters to send to the API endpoint

	for the update signed in user operation.

	Typically these are written to a http.Request.
*/
type UpdateSignedInUserParams struct {

	/* Body.

	   To change the email, name, login, theme, provide another one.
	*/
	Body *models.UpdateUserCommand

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update signed in user params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateSignedInUserParams) WithDefaults() *UpdateSignedInUserParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update signed in user params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateSignedInUserParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update signed in user params
func (o *UpdateSignedInUserParams) WithTimeout(timeout time.Duration) *UpdateSignedInUserParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update signed in user params
func (o *UpdateSignedInUserParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update signed in user params
func (o *UpdateSignedInUserParams) WithContext(ctx context.Context) *UpdateSignedInUserParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update signed in user params
func (o *UpdateSignedInUserParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update signed in user params
func (o *UpdateSignedInUserParams) WithHTTPClient(client *http.Client) *UpdateSignedInUserParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update signed in user params
func (o *UpdateSignedInUserParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update signed in user params
func (o *UpdateSignedInUserParams) WithBody(body *models.UpdateUserCommand) *UpdateSignedInUserParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update signed in user params
func (o *UpdateSignedInUserParams) SetBody(body *models.UpdateUserCommand) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateSignedInUserParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
