// Code generated by go-swagger; DO NOT EDIT.

package teams

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewUpdateTeamPreferencesParams creates a new UpdateTeamPreferencesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateTeamPreferencesParams() *UpdateTeamPreferencesParams {
	return &UpdateTeamPreferencesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateTeamPreferencesParamsWithTimeout creates a new UpdateTeamPreferencesParams object
// with the ability to set a timeout on a request.
func NewUpdateTeamPreferencesParamsWithTimeout(timeout time.Duration) *UpdateTeamPreferencesParams {
	return &UpdateTeamPreferencesParams{
		timeout: timeout,
	}
}

// NewUpdateTeamPreferencesParamsWithContext creates a new UpdateTeamPreferencesParams object
// with the ability to set a context for a request.
func NewUpdateTeamPreferencesParamsWithContext(ctx context.Context) *UpdateTeamPreferencesParams {
	return &UpdateTeamPreferencesParams{
		Context: ctx,
	}
}

// NewUpdateTeamPreferencesParamsWithHTTPClient creates a new UpdateTeamPreferencesParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateTeamPreferencesParamsWithHTTPClient(client *http.Client) *UpdateTeamPreferencesParams {
	return &UpdateTeamPreferencesParams{
		HTTPClient: client,
	}
}

/*
UpdateTeamPreferencesParams contains all the parameters to send to the API endpoint

	for the update team preferences operation.

	Typically these are written to a http.Request.
*/
type UpdateTeamPreferencesParams struct {

	// Body.
	Body *models.UpdatePrefsCmd

	// TeamID.
	TeamID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update team preferences params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTeamPreferencesParams) WithDefaults() *UpdateTeamPreferencesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update team preferences params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTeamPreferencesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update team preferences params
func (o *UpdateTeamPreferencesParams) WithTimeout(timeout time.Duration) *UpdateTeamPreferencesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update team preferences params
func (o *UpdateTeamPreferencesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update team preferences params
func (o *UpdateTeamPreferencesParams) WithContext(ctx context.Context) *UpdateTeamPreferencesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update team preferences params
func (o *UpdateTeamPreferencesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update team preferences params
func (o *UpdateTeamPreferencesParams) WithHTTPClient(client *http.Client) *UpdateTeamPreferencesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update team preferences params
func (o *UpdateTeamPreferencesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update team preferences params
func (o *UpdateTeamPreferencesParams) WithBody(body *models.UpdatePrefsCmd) *UpdateTeamPreferencesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update team preferences params
func (o *UpdateTeamPreferencesParams) SetBody(body *models.UpdatePrefsCmd) {
	o.Body = body
}

// WithTeamID adds the teamID to the update team preferences params
func (o *UpdateTeamPreferencesParams) WithTeamID(teamID string) *UpdateTeamPreferencesParams {
	o.SetTeamID(teamID)
	return o
}

// SetTeamID adds the teamId to the update team preferences params
func (o *UpdateTeamPreferencesParams) SetTeamID(teamID string) {
	o.TeamID = teamID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateTeamPreferencesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param team_id
	if err := r.SetPathParam("team_id", o.TeamID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
