// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Correlation Correlation is the model for correlations definitions
//
// swagger:model Correlation
type Correlation struct {

	// config
	Config *CorrelationConfig `json:"config,omitempty"`

	// Description of the correlation
	// Example: Logs to Traces
	Description string `json:"description,omitempty"`

	// Label identifying the correlation
	// Example: My Label
	Label string `json:"label,omitempty"`

	// OrgID of the data source the correlation originates from
	// Example: 1
	OrgID int64 `json:"orgId,omitempty"`

	// Provisioned True if the correlation was created during provisioning
	Provisioned bool `json:"provisioned,omitempty"`

	// UID of the data source the correlation originates from
	// Example: d0oxYRg4z
	SourceUID string `json:"sourceUID,omitempty"`

	// UID of the data source the correlation points to
	// Example: PE1C5CBDA0504A6A3
	TargetUID string `json:"targetUID,omitempty"`

	// Unique identifier of the correlation
	// Example: 50xhMlg9k
	UID string `json:"uid,omitempty"`
}

// Validate validates this correlation
func (m *Correlation) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateConfig(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Correlation) validateConfig(formats strfmt.Registry) error {
	if swag.IsZero(m.Config) { // not required
		return nil
	}

	if m.Config != nil {
		if err := m.Config.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("config")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("config")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this correlation based on the context it is used
func (m *Correlation) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateConfig(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Correlation) contextValidateConfig(ctx context.Context, formats strfmt.Registry) error {

	if m.Config != nil {

		if swag.IsZero(m.Config) { // not required
			return nil
		}

		if err := m.Config.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("config")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("config")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *Correlation) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Correlation) UnmarshalBinary(b []byte) error {
	var res Correlation
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
